function X = specsol(theta0,w)
%Function to compute simple transpose of vec(ftheta) to check spectra
%along the nonidentification curve
% //now obtain the spectral density matrix under the given parameter values
tau = theta0(1);
beta=theta0(2);
nu = theta0(3); 
phi= theta0(4);
pistar=theta0(5);
psi1 = theta0(6);
psi2 = theta0(7);
rhor = theta0(8);
rhog = theta0(9);
rhoz = theta0(10);
sig2r = theta0(11);
sig2g = theta0(12);
sig2z = theta0(13);
kap=(tau*(1-nu))/(nu*phi*pistar);
Gam0=[ 1 0 0 0 0 0 0 0;
0 1 0 0 0 0 0 0;
0 (1-rhor)*psi2 1 -(1-rhor)*psi2 -(1-rhor)*psi1 0 0 0;
0 -kap 0 kap -1 0 beta 0 ;
rhoz/tau (1-rhog) -1/tau -1 0 0 1/tau 1 ;
0 0 0 0 0 0 0 0;
0 0 0 0 1 0 0 0
0 0 0 1 0 0 0 0;
];
Gam1=[ rhoz 0 0 0 0 0 0 0 ;
0 rhog 0 0 0 0 0 0 ;
0 0 rhor 0 0 0 0 0;
0 0 0 0 0 0 0 0 ;
0 0 0 0 0 0 0 0 ;
0 -1 0 1 0 -1 0 0 ;
0 0 0 0 0 0 1 0;
0 0 0 0 0 0 0 1;
];
Gam2=zeros(8,3); Gam2(1:3,1:3)=eye(3);
Gam3=zeros(8,2); Gam3(7:8,7:8)=eye(2);
cons=zeros(8,1);
[G1,C,impact,fmat,fwt,ywt,gev,eu]=gensys(Gam0,Gam1,cons,Gam2,Gam3);

spec=zeros(length(w),16);
A = zeros(4,8); 
A(1:4,3:6)=eye(4); %construct the A matrix as on p. 17, except for the lag operator,
%which is replaced by exp(-1i*w(i)) and added in a loop later
SIG=[sig2z,0,0;0,sig2g,0;0,0,sig2r]; %covariance matrix
i=1;
while i<=length(w); %compute spectrum (see gmatrix.m for details)
exe=exp(-1i*w(i));
A(1,3)=exe;
H=A*((eye(8) - G1*exe)\impact);
ftheta=(1/(2*pi))*H*SIG*H'; 
spec(i,:)=ftheta(:).'; %take vec(ftheta).' to compactly fit values into 1 row
i=i+1;
end;
X=spec;
end